﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SmarterNotify.Data.Events
{
    public class EventCondition
    {
        public enum ArgumentType
        {
            LessThan,
            Equals,
            GreaterThan,
            Contains
        }
        public enum ConditionType
        {
            ProfileUnavailable,
            ProfileUnauthorized
        }

        public string ConditionGUID { get; set; }
        public string Name { get; set; }
        public ArgumentType Argument = ArgumentType.Equals;
        public ConditionType Condition = ConditionType.ProfileUnavailable;
        public string ConditionValue { get; set; }

        public EventCondition()
        {
            ConditionGUID = Guid.NewGuid().ToString("N");
            Name = string.Empty;
            Argument = ArgumentType.Equals;
            Condition = ConditionType.ProfileUnavailable;
            ConditionValue = string.Empty;
        }
    }
}