﻿using System;
using System.Collections.Generic;
using System.Text;
using SmarterNotify.DataHandlers;

namespace SmarterNotify.Data.Events
{
    public class ReminderEvent
    {
        public string EventGUID { get; set; }
        public string Name { get; set; }
        //public List<EventCondition> Conditions { get; set; } // not implemented at this time...
        public string Message { get; set; }
        public bool Enabled { get; set; }
        public int MaxOccurencesPerHour { get; set; }
        private DateTime FirstIterationThisHourUTC { get; set; }
        private int NumOccurencesThisHour { get; set; }

        public ReminderEvent()
        {
            EventGUID = Guid.NewGuid().ToString("N");
            Name = string.Empty;
            //Conditions = new List<EventCondition>();
            Message = string.Empty;
            Enabled = false;
            MaxOccurencesPerHour = 10;
            FirstIterationThisHourUTC = DateTime.MinValue;
            NumOccurencesThisHour = 0;
        }

        public void FireEvent()
        {
            // make sure this event meets all of it's conditions
            // ... not implemented

            // make sure it can be hit...
            if (FirstIterationThisHourUTC == DateTime.MinValue || FirstIterationThisHourUTC == DateTime.MaxValue)
                FirstIterationThisHourUTC = DateTime.UtcNow;
            if (FirstIterationThisHourUTC.AddHours(1.0) <= DateTime.UtcNow)
            {
                FirstIterationThisHourUTC = DateTime.UtcNow;
                NumOccurencesThisHour = 0;
            }
            if (NumOccurencesThisHour < MaxOccurencesPerHour)
            {
                Reminder evtReminder = new Reminder();
                evtReminder.Subject = this.Name;
                evtReminder.BodyText = this.Message;
                evtReminder.OwnerProfileName = "SmarterNotify";
                evtReminder.TimeOccurredUTC = DateTime.UtcNow;
                evtReminder.SnoozeTimeUTC = DateTime.MinValue;
                evtReminder.ReminderType = Reminder.AlertType.Internal;
                InternalReminderHandler.SaveReminder(evtReminder, true);

                NumOccurencesThisHour++;
            }
        }
    }
}