﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using SmarterNotify.HelperClasses;

namespace SmarterNotify.Data
{
    public class Settings
    {
        public string NotificationSoundFile { get; set; }
        public bool NotifyPopupBalloon { get; set; }
        public bool NotifyAnimateIcon { get; set; }
        public bool NotifyPlaySound { get; set; }
        public bool NotifyShowInterface { get; set; }
        public bool NoTaskbarMinimized { get; set; }
        public bool NotifyOnlyMinimized { get; set; }
        public bool EnableErrorLogging { get; set; }
        public bool EnableErrorNotifications { get; set; }
        public bool EnableConnectionLogging { get; set; }
        public bool EnableConnectionNotifications { get; set; }
        public bool EnableNotificationLogging { get; set; }
        public bool AutoNavigateNewAlerts { get; set; }
        public bool MinimizeOnDismissAll { get; set; }
        public bool MessageOnFirstMinimize { get; set; }
        public bool NotifyReadToMe { get; set; }
        public bool IsFirstLoad { get; set; }
        public int SoundInterval { get; set; }

        public Settings()
        {
            // default settings
            NotificationSoundFile = AppPath.AppBinPath + "\\Sounds\\NewReminder.wav";
            NotifyPopupBalloon = true;
            NotifyAnimateIcon = true;
            NotifyPlaySound = true;
            NotifyShowInterface = false;
            NoTaskbarMinimized = true;
            NotifyOnlyMinimized = false;
            EnableErrorLogging = true;
            EnableErrorNotifications = false;
            EnableConnectionLogging = false;
            EnableConnectionNotifications = false;
            EnableNotificationLogging = false;
            AutoNavigateNewAlerts = true;
            MinimizeOnDismissAll = false;
            MessageOnFirstMinimize = true;
            NotifyReadToMe = true;
            IsFirstLoad = true;
            SoundInterval = -1;
        }
        public bool ShouldShowSmarterNotify()
        {
            if (EnableErrorNotifications || EnableConnectionNotifications)
                return true;

            return false;
        }
        public string GetSoundFile()
        {
            string soundFileLoc = NotificationSoundFile;
            if (soundFileLoc.StartsWith(".\\"))
            {
                return soundFileLoc.Substring(0, 2).Replace(".\\", AppPath.AppBinPath) +
                    soundFileLoc.Substring(2, soundFileLoc.Length - 2);
            }
            else
                return soundFileLoc;
        }
        public void SetSoundFile(string soundFile)
        {
            if (soundFile.StartsWith(AppPath.AppBinPath))
                NotificationSoundFile = soundFile.Replace(AppPath.AppBinPath, ".\\");
            else
                NotificationSoundFile = soundFile;
        }
    }
}