﻿using System;
using System.Collections.Generic;
using System.Text;
using SmarterNotify.Data;
using SmarterNotify.Connector;

namespace SmarterNotify.DataHandlers
{
    public class ReminderHandler
    {
        public static List<Reminder> GetAllProfileReminders(bool includeSnoozedItems)
        {
            List<Reminder> retVal = new List<Reminder>();

            foreach (ConnectionProfile profile in ConnectionProfileHandler.GetAllProfiles())
            {
                if (profile != null)
                    retVal.AddRange(profile.GetAllReminders(includeSnoozedItems));
            }

            return retVal;
        }
        public static List<Reminder> GetAllProfileReminders(bool includeSnoozedItems, ConnectionProfile.ConnectionProfileType profileType, List<Reminder> reminders)
        {
            List<Reminder> retVal = new List<Reminder>();

            foreach (Reminder reminder in reminders)
            {
                ConnectionProfile profile = ConnectionProfileHandler.GetProfile(reminder.ProfileGUID);

                if (profile != null)
                {
                    if (profileType == profile.ConnectionType)
                        retVal.Add(reminder);
                }
            }

            return retVal;
        }
        public static List<Reminder> GetAllProfileReminders(bool includeSnoozedItems, ConnectionProfile profile, List<Reminder> reminders)
        {
            List<Reminder> retVal = new List<Reminder>();
            if (profile != null)
            {
                foreach (Reminder reminder in reminders)
                {
                    if (profile.ProfileGUID == reminder.ProfileGUID)
                        retVal.Add(reminder);
                }
            }

            return retVal;
        }
        public static void DismissAllProfilesReminders()
        {
            foreach (ConnectionProfile profile in ConnectionProfileHandler.GetAllProfiles())
                profile.DismissAllReminders();
        }
        public static void DismissAllSMProfilesReminders()
        {
            foreach (ConnectionProfile profile in ConnectionProfileHandler.GetSMProfiles())
                profile.DismissAllReminders();
        }
        public static void DismissAllSSProfilesReminders()
        {
            foreach (ConnectionProfile profile in ConnectionProfileHandler.GetSSProfiles())
                profile.DismissAllReminders();
        }
        public static void DismissAllSTProfilesReminders()
        {
            foreach (ConnectionProfile profile in ConnectionProfileHandler.GetSTProfiles())
                profile.DismissAllReminders();
        }
        public static void DismissAllEPProfilesReminders()
        {
            foreach (ConnectionProfile profile in ConnectionProfileHandler.GetExternalProfiles())
                profile.DismissAllReminders();
        }
        public static void DismissAllPlgProfilesReminders()
        {
            foreach (ConnectionProfile profile in ConnectionProfileHandler.GetPluginProfiles())
                profile.DismissAllReminders();
        }
    }
}