﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;
using SmarterNotify.DataHandlers;
using SmarterNotify.Data;
using System.Reflection;

namespace SmarterNotify.HelperClasses
{
    public class AppPath
    {
        public static void CheckLogFiles()
        {
            // will create all the directories needed by the application
            string appStore = AppPath.AppStoragePath;
            if (!Directory.Exists(appStore + "Logs\\"))
                Directory.CreateDirectory(appStore + "Logs\\");
            if (!File.Exists(appStore + "Logs\\ErrorLog.txt"))
                File.Create(appStore + "Logs\\ErrorLog.txt");
            if (!File.Exists(appStore + "Logs\\ConnectionLog.txt"))
                File.Create(appStore + "Logs\\ConnectionLog.txt");
            if (!File.Exists(appStore + "Logs\\NotificationLog.txt"))
                File.Create(appStore + "Logs\\NotificationLog.txt");
        }
        public static string AppBinPath
        {
            get
            {
                return Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);
            }
        }
        public static string AppStoragePath
        {
            get 
            {
                string envPath = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData);
                if (!envPath.EndsWith("\\"))
                    envPath += "\\";
                string appPath = envPath + "SmarterNotify\\";
                if (!Directory.Exists(appPath))
                    Directory.CreateDirectory(appPath);
                return appPath;
            }
        }
        public static string ProfilesFilePath
        {
            get { return AppPath.AppStoragePath + "ConnectionProfiles.xml"; }
        }
        public static string SettingsFilePath
        {
            get { return AppPath.AppStoragePath + "Settings.xml"; }
        }
        public static string EventsFilePath
        {
            get { return AppPath.AppStoragePath + "Events.xml"; }
        }
        public static string BrowserNotificationFilePath
        {
            get { return AppPath.AppStoragePath + "TempNote.html"; }
        }
        public static string InternalAlertsFilePath
        {
            get { return AppPath.AppStoragePath + "InternalAlerts.xml"; }
        }
        public static string ProviderFilePath
        {
            get { return AppPath.AppStoragePath + "Providers.xml"; }
        }
        public static string VoiceDictionaryFilePath
        {
            get { return AppPath.AppStoragePath + "VoiceDictionary.xml"; }
        }
        public static string PluginPath
        {
            get
            {
                if (!Directory.Exists(AppPath.AppBinPath + "\\Plugins"))
                    Directory.CreateDirectory(AppPath.AppBinPath + "\\Plugins");

                return AppPath.AppBinPath + "\\Plugins\\";
            }
        }
        public static string ErrorLogFilePath
        {
            get
            {
                string dataSource = AppPath.AppStoragePath + "Logs\\ErrorLog.txt";
                if (!Directory.Exists(AppPath.AppStoragePath + "Logs\\"))
                    Directory.CreateDirectory(AppPath.AppStoragePath + "Logs\\");
                if (!File.Exists(dataSource))
                    File.Create(dataSource);
                return dataSource;
            }
        }
        public static string ErrorLogBakFilePath
        {
            get
            {
                string dataSource = AppPath.AppStoragePath + "Logs\\ErrorLog.bak";
                if (!Directory.Exists(AppPath.AppStoragePath + "Logs\\"))
                    Directory.CreateDirectory(AppPath.AppStoragePath + "Logs\\");
                return dataSource;
            }
        }
        public static string ConnectionLogFilePath
        {
            get
            {
                string dataSource = AppPath.AppStoragePath + "Logs\\ConnectionLog.txt";
                if (!Directory.Exists(AppPath.AppStoragePath + "Logs\\"))
                    Directory.CreateDirectory(AppPath.AppStoragePath + "Logs\\");
                if (!File.Exists(dataSource))
                    File.Create(dataSource);
                return dataSource;
            }
        }
        public static string ConnectionLogBakFilePath
        {
            get
            {
                string dataSource = AppPath.AppStoragePath + "Logs\\ConnectionLog.bak";
                if (!Directory.Exists(AppPath.AppStoragePath + "Logs\\"))
                    Directory.CreateDirectory(AppPath.AppStoragePath + "Logs\\");
                return dataSource;
            }
        }
        public static string NotificationLogFilePath
        {
            get
            {
                string dataSource = AppPath.AppStoragePath + "Logs\\NotificationLog.txt";
                if (!Directory.Exists(AppPath.AppStoragePath + "Logs\\"))
                    Directory.CreateDirectory(AppPath.AppStoragePath + "Logs\\");
                if (!File.Exists(dataSource))
                    File.Create(dataSource);
                return dataSource;
            }
        }
        public static string NotificationLogBakFilePath
        {
            get
            {
                string dataSource = AppPath.AppStoragePath + "Logs\\NotificationLog.bak";
                if (!Directory.Exists(AppPath.AppStoragePath + "Logs\\"))
                    Directory.CreateDirectory(AppPath.AppStoragePath + "Logs\\");
                return dataSource;
            }
        }
    }
}