﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Speech.Synthesis;

namespace SmarterNotify.HelperClasses
{
    public class VoiceThread
    {
        public static Queue<string> VoiceQueue = new Queue<string>();
        public static object VoiceLocker = new object();
        public static bool IsQueueProcessing = false;

        public static void AddToQueue(string text)
        {
            lock (VoiceLocker)
            {
                VoiceQueue.Enqueue(text);
                if (!IsQueueProcessing)
                {
                    StartVoiceQueue();
                    IsQueueProcessing = true;
                }
            }
        }
        private static void StartVoiceQueue()
        {
            Thread thd = new Thread(new ThreadStart(CycleVoiceQueue));
            thd.IsBackground = true;
            thd.Name = "VoiceQueueCycleThroughAndPlay";
            thd.Start();
        }
        private static void CycleVoiceQueue()
        {
            while (VoiceQueue.Count > 0)
            {
                using (var synth = new SpeechSynthesizer())
                {
                    string message = string.Empty;
                    lock (VoiceLocker)
                    {
                        //TODO: Add dictionary logic to check for keywords and replace them with their allocated value
                        message = VoiceQueue.Dequeue().Replace("KB", "K B");
                    }
                    synth.Speak(message);
                }

                Thread.Sleep(1000);
            }
            lock (VoiceLocker)
            {
                IsQueueProcessing = false;
            }
        }
    }
}
