﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace SmarterNotify.HelperClasses
{
    public class WindowStateManager
    {
        public enum StateTypes
        {
            Normal,
            Minimized
        }
        public static ReaderWriterLock Locker = new ReaderWriterLock();
        private static StateTypes _CurrentState = StateTypes.Normal;
        public static StateTypes CurrentState 
        {
            get
            {
                Locker.AcquireReaderLock(-1);
                var retVal = _CurrentState;
                Locker.ReleaseReaderLock();
                return retVal;
            }
            set
            {
                Locker.AcquireWriterLock(-1);
                _CurrentState = value;
                Locker.ReleaseWriterLock();
            }
        }
    }
}
