﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Diagnostics;
using SmarterNotify.HelperClasses;

namespace SmarterNotify
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        /// 

        [STAThread]
        static void Main(params string[] args)
        {
            // check to make sure multiple instances of this application cannot start
            Process[] curNotifies = Process.GetProcessesByName(Process.GetCurrentProcess().ProcessName);
            if (curNotifies.Length > 1)
            {
                MessageBox.Show("You already have SmarterNotify running on this machine! Check your task tray for any open instances of SmarterNotify.",
                    "Multiple Instances Detected", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                Application.Exit();
                return;
            }

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            if (args != null && args.Length > 0 && args[0].ToLowerInvariant().Equals("/starthidden"))
            {
                frmMain newMain = new frmMain();
                newMain.Visible = false;
                newMain.Hide(); 
                newMain.WindowState = FormWindowState.Minimized;
                WindowStateManager.CurrentState = WindowStateManager.StateTypes.Minimized;                
                Application.Run();
            }
            else
                Application.Run(new frmMain());          
        }
    }
}
