﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SmarterNotify.Connector
{
    public interface INotifyProvider
    {
        IsAvailableResult PingService(string authUsername, string authPassword, string dataUsername);

        RemindersResult GetAllReminders(string authUsername, string authPassword, string dataUsername, List<InputValue> customVariables);

        ReminderResult GetReminder(string authUsername, string authPassword, string dataUsername, string reminderID, List<InputValue> customVariables);

        GenericResult DismissAllReminders(string authUsername, string authPassword, string dataUsername, List<InputValue> customVariables);

        GenericResult DismissReminder(string authUsername, string authPassword, string dataUsername, string reminderID, List<InputValue> customVariables);

        GenericResult SnoozeNotification(string authUsername, string authPassword, string dataUsername, string reminderID, int snoozeSeconds, List<InputValue> customVariables);

        IntRequestResult GetReminderCount(string authUsername, string authPassword, string dataUsername, List<InputValue> customVariables);

        IntRequestResult GetNewReminderCount(string authUsername, string authPassword, string dataUsername, string lastCheckDateUTC, List<InputValue> customVariables);
    }
}