﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SmarterNotify.Connector
{
    [Serializable]
    public class IsAvailableResult
    {
        public bool IsAvailable;

        public IsAvailableResult()
        {
            IsAvailable = false;
        }
    }
    [Serializable]
    public class GenericResult
    {
        public string Message;
        public bool Result;
        public int ResultCode;

        public GenericResult()
        {
            Message = string.Empty;
            Result = false;
            ResultCode = -1;
        }
    }
    [Serializable]
    public class ReminderResult
    {
        public string Message;
        public bool Result;
        public int ResultCode;
        public ReminderValue Reminder;

        public ReminderResult()
        {
            Message = string.Empty;
            Result = false;
            ResultCode = -1;
            Reminder = new ReminderValue();
        }
    }
    [Serializable]
    public class IntRequestResult
    {
        public string Message;
        public bool Result;
        public int ResultCode;
        public int RequestResult;

        public IntRequestResult()
        {
            Message = string.Empty;
            Result = false;
            ResultCode = -1;
            RequestResult = -1;
        }
    }
    [Serializable]
    public class RemindersResult
    {
        public string Message;
        public bool Result;
        public int ResultCode;
        public List<ReminderValue> Reminders;

        public RemindersResult()
        {
            Message = string.Empty;
            Result = false;
            ResultCode = -1;
            Reminders = new List<ReminderValue>();
        }
    }

    #region Helper Classes
    [Serializable]
    public class ReminderValue
    {
        public List<ReminderValuePair> ReminderAttributes;

        public ReminderValue()
        {
            ReminderAttributes = new List<ReminderValuePair>();
        }
    }
    [Serializable]
    public class ReminderValuePair
    {
        public enum ReminderAttributes
        {
            ReminderID,
            UserID,
            Subject,
            PhonicSubject,
            CategoryType,
            BodyText,
            SnoozeTimeUTC,
            TimeOccurredUTC,
            Other
        }
        public ReminderAttributes Key;
        public string OtherKey;
        public string Val;
        public ReminderValuePair() { }
        public ReminderValuePair(ReminderAttributes key, string val)
        {
            this.Key = key;
            this.Val = val;
        }
        public ReminderValuePair(string otherKey, string val)
        {
            this.Key = ReminderAttributes.Other;
            this.OtherKey = otherKey;
            this.Val = val;
        }
    }
    #endregion
}