﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using SmarterNotify.Data;
using SmarterNotify.HelperClasses;

namespace SmarterNotify
{
    public partial class frmConnectionProfileConflict : Form
    {
        public delegate void OnActionDel(bool toggle);
        public event OnActionDel OnAction;

        public int NumAttempts = 1;
        public ConnectionProfile ConflictedProfile = new ConnectionProfile();

        public frmConnectionProfileConflict()
        {
            InitializeComponent();
        }
        private void frmConnectionProfileConflict_Load(object sender, EventArgs e)
        {
        }
        private void btnAdd_Click(object sender, EventArgs e)
        {
            OnAction(true);
            this.Close();
        }
        private void btnEdit_Click(object sender, EventArgs e)
        {
            OnAction(false);
            this.Close();
        }
        private void btnRetry_Click(object sender, EventArgs e)
        {
            // retry connecting...
            bool isAvailable = ConflictedProfile.IsServiceAvailable();
            if (!isAvailable)
            {
                NumAttempts++;
                lblNumberAttempts.Text = NumAttempts.ToString();
            }
            else
            {
                OnAction(true);
                this.Close();
            }
        }
        private void btnHelp_Click(object sender, EventArgs e)
        {
            ViewManager.OpenHelp(ViewManager.HelpCriteria.ConnectionProfileConflict);
        }
        private void frmConnectionProfileConflict_HelpRequested(object sender, HelpEventArgs hlpevent)
        {
            ViewManager.OpenHelp(ViewManager.HelpCriteria.ConnectionProfileConflict);
        }
    }
}