﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using SmarterNotify.DataHandlers;
using SmarterNotify.HelperClasses;

namespace SmarterNotify
{
    public partial class frmFirstLoad : Form
    {
        public enum Steps
        {
            Step1,
            Step2
        }
        public Steps CurrentStep = Steps.Step1;
        public frmFirstLoad()
        {
            InitializeComponent();
        }

        public bool HasSetSettings = false;
        private void btnNext_Click(object sender, EventArgs e)
        {
            ShowStep2();
        }

        private void frmFirstLoad_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (!HasSetSettings)
                SettingsHandler.GlobalSettings.NotifyReadToMe = false;

            SettingsHandler.GlobalSettings.IsFirstLoad = false;
            SettingsHandler.SaveSettings();
            HasSetSettings = true;
        }
        private void btnFinish_Click(object sender, EventArgs e)
        {
            SettingsHandler.GlobalSettings.NotifyReadToMe = chkEnableVoice.Checked;
            SettingsHandler.GlobalSettings.IsFirstLoad = false;
            SettingsHandler.SaveSettings();
            HasSetSettings = true;
            this.Close();
        }
        private void frmFirstLoad_Load(object sender, EventArgs e)
        {
            this.Size = new Size(469, 238);
            grpWelcome1.Location = new Point(12, 12);
            grpWelcome2.Location = new Point(12, 12);
            ShowStep1();
        }
        public void ShowStep1()
        {
            grpWelcome1.Visible = true;
            grpWelcome2.Visible = false;

            btnFinish.Visible = false;
            btnPrevious.Visible = false;
            btnNext.Visible = true;
            CurrentStep = Steps.Step1;
        }
        public void ShowStep2()
        {
            grpWelcome1.Visible = false;
            grpWelcome2.Visible = true;

            btnFinish.Visible = true;
            btnPrevious.Visible = true;
            btnNext.Visible = false;
            CurrentStep = Steps.Step2;
        }
        private void btnPrevious_Click(object sender, EventArgs e)
        {
            switch (CurrentStep)
            {
                case Steps.Step2:
                    ShowStep1();
                    break;
            }
        }
        private void btnHelp_Click(object sender, EventArgs e)
        {
            ViewManager.OpenHelp(ViewManager.HelpCriteria.WelcomeWindow);
        }
        private void frmFirstLoad_HelpRequested(object sender, HelpEventArgs hlpevent)
        {
            ViewManager.OpenHelp(ViewManager.HelpCriteria.WelcomeWindow);
        }
    }
}