﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using SmarterNotify.Data.Events;
using SmarterNotify.HelperClasses;

namespace SmarterNotify
{
    public partial class frmNotificationCondition : Form
    {
        public delegate void OnUpdateDel();
        public event OnUpdateDel OnUpdate;

        public ReminderEvent ReminderEvt = new ReminderEvent();
        public string ConditionGUID = string.Empty;

        public frmNotificationCondition()
        {
            InitializeComponent();
        }
        public frmNotificationCondition(string ConditionGUID)
        {
            this.ConditionGUID = ConditionGUID;
        }

        private void frmNotificationCondition_Load(object sender, EventArgs e)
        {
            // fill out the lists with the available names from the condition enums
            cboArgument.Items.AddRange(ViewManager.GetFormattedEnumNames(typeof(EventCondition.ArgumentType)).ToArray());
            if (cboArgument.Items.Count > 0)
                cboArgument.SelectedIndex = 0;

            cboCondition.Items.AddRange(ViewManager.GetFormattedEnumNames(typeof(EventCondition.ConditionType)).ToArray());
            if (cboCondition.Items.Count > 0)
                cboCondition.SelectedIndex = 0;

            if (!string.IsNullOrEmpty(ConditionGUID))
            {
                // existing one, load it's properties into the form
            }
        }
        private void btnSave_Click(object sender, EventArgs e)
        {
            OnUpdate();
            this.Close();
            this.Dispose();
        }
        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
            this.Dispose();
        }
    }
}